#include <iostream>
#include <iomanip>
#include <stdio.h>
#include "Graph.h"

using namespace std;

Graph::Graph(char *fileName) {
  FILE *fin;
  
  if((fin = fopen(fileName, "r")) == NULL) {
    cout << "Chyba: Soubor " << fileName << " se nepodarilo otevrit" << endl;
    exit(1);
  }

  fscanf(fin, "%d\n", &nodes);

  if(nodes < 2) {
    cout << "Chyba: Je zadan nedostatecny pocet vrcholu (" << nodes << ")" << endl;
    exit(1);
  }

  graph = new int *[nodes];
  for(int i = 0; i < nodes; i++) graph[i] = new int[nodes];

  edges = 0;
  char line[2 * nodes + 3];
  
  for(int i = 0; i < nodes; i++) {
    fgets(line, 2 * nodes + 3, fin);

    for(int j = 0; j < nodes; j++) {
      if(j >= i) {
        if(line[2 * j] == '0') graph[i][j] = 0;
        else graph[i][j] = ++edges;
      } else {
        if((line[2 * j] - '0') > 0) {
          if(graph[j][i] == 0) {
            cout << "Chyba: Mezi uzly " << (i + 1) << " a " << (j + 1) << " nema byt hrana" << endl;
            exit(1);
          } else graph[i][j] = graph[j][i];
        }	else {
          if(graph[j][i] > 0) {
            cout << "Chyba: Mezi uzly " << (i + 1) << " a " << (j + 1) << " ma byt hrana" << endl;
            exit(1);
          } else graph[i][j] = 0;
        }
      }
    }
  }

  fclose(fin);

  for(int i = 0; i < nodes; i++) {
    for(int j = 0; j < nodes; j++)
      cout << setw(3) << graph[i][j];
    
    cout << endl;
  }
  cout << endl << endl;
}

void Graph::getNeighbours(int n, bool *edges, int *res) {
  int count = 0;

  for(int i = 0; i < nodes; i++)
    if(graph[n][i] && edges[graph[n][i] - 1]) res[count++] = i;

  for(int i = count; i < nodes; i++) res[i] = -1;
}

void Graph::print(bool *edges) {
  for(int i = 0; i < nodes; i++) {
    for(int j = 0; j < nodes; j++) {
      if(graph[i][j] && edges[graph[i][j] - 1]) cout << "1 ";
        else cout << "0 ";
    }

    cout << endl;
  }
}

Graph::~Graph() {
  for(int i = 0; i < nodes; i++) delete [] graph[i];
  delete [] graph;
}

